// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#include <vector>

#include "source.h"
#include "filter.h"
#include "cfg.h"
#include "view.h"
#include "http_auth.h"

class http_server : public interface
{
private:
	const double fps;
	const int quality, time_limit;
	const std::vector<filter *> *const f;
	resize *const r;
	const int resize_w, resize_h;
	source *const motion_compatible;
	const bool allow_admin, archive_acces;
	configuration_t *const cfg;
	http_auth *const auth;
	const std::string snapshot_dir;
	const bool is_rest;
	instance_t *const views, *const limit_to;
	const bool use_previous_when_fail;

	int fd;

public:
	http_server(configuration_t *const cfg, http_auth *const auth, instance_t *const limit_to, const std::string & id, const std::string & descr, const std::string & http_adapter, const int http_port, const double fps, const int quality, const int time_limit, const std::vector<filter *> *const f, resize *const r, const int resize_w, const int resize_h, source *const motion_compatible, const bool allow_admin, const bool archive_access, const std::string & snapshot_dir, const bool is_rest, instance_t *const views, const bool use_previous_when_fail);
	virtual ~http_server();

	static void mjpeg_stream_url(configuration_t *const cfg, const std::string & id, std::string *const img_url, std::string *const page_url);

	void operator()() override;
};
